#same Clustalw webservice, this time we use mod_python


def _toParameters(queryData):
    commandName="clustalw"
    parameters=[]
    tempfiles=[]
    outputfiles=[]

    from bioMoby import Parameter 
    import random

    tfs='/tmp/tmp'+ `int(random.random()*1000000)`
    
    for datum in queryData:
        if datum.__class__ is Parameter:
            parameters.append("-"+datum.articleName+"="+datum.value)
        else:
            try:
                fp=file(tfs,"w")
                fp.write(datum.content)
                fp.close
                parameters.append("-infile="+tfs)
                tempfiles.append(tfs)
            except:
                pass
                
    tempfiles.append(tfs+".dnd")
    outputfiles.append(tfs+".aln")
            
    return (commandName, " type=p -align "+" ".join(parameters), tempfiles, outputfiles)
    
def clustalw(mobyContent):
    from bioMoby import Dispatcher, LocalInvocator
    
    d=Dispatcher(mobyContent, LocalInvocator, _toParameters)
    
    return d.execute()

from ZSI import dispatch
from mod_python import apache
from bioMoby.webservice import TCBioMoby

def handler(req):
	if req.method=='GET':
		if req.args=='wsdl':
			req.content_type='text/xml'
			req.sendfile('clustal.wsdl')
		else:
			try:
				util.redirect(req,"http://www.clustal-webpage.org")
			except:
				req.content_type='text/html'
				req.write("<html><head><title>Clustalw</title></head><body>Clustalw</body></html>")

	else:
		dispatch.AsHandler(modules=(Clustalw,),request=req, typesmodule=TCBioMoby)

	return apache.OK
